!include <qna.qlb>

define game <QNA Demo>
	asl-version <350>
	gametype singleplayer
	start <room1>
	game author <Justin Bailey>
	game version <1.1>
	game copyright <2005 Junkosoft>
	game info <Transformations and clothing powered by QNA. |nType readme for more details.>
	startscript {
		do <qna.setup(1.1)>
		msg <Welcome to QNA - Quest Nucleic Acid. This demo file is designed to show you step-by-step how to use the QNA transformation engine. Just travel from room to room to get instructions. Feel free to look at this code in QDK or Notepad for examples of how to use everything.>
	}
	beforeturn 
	afterturn 
	command <exit> msg <Try typing |iquit|xi instead.>
	command <out> msg <That's not going to happen, #name[sex]#.>
end define

define room <room1>
	alias <Red Room>
	prefix <the>
	look <To start out, make sure you include qna.qlb in your game. Then, in the startscript area, execute the procedure qna.setup with a parameter of the current version (1.1). If you've done these steps then using the |iinventory|xi command or typing |ilook at self|xi will cause Quest to show your current statistics.>
	southeast <room2>
end define

define room <room2>
	alias <Purple Room>
	prefix <the>
	look <This room is all about gender transformations. Simply, to change the player's sex, set the 'sex' numeric variable to either 1 (male) or 0 (female). This feature can be demonstrated by trying to take the sword which is stuck in a large rock in the center of this room.>
	south <room3>
	northwest <room1>

	define object <sword>
		alias <sword>
		look <This is a massive sword lodged deeply in a rock. There's some strange foreign writing on the rock which basically says, "Only the King may have this sword. All who fail are mere peasant girls.">
		take {
			if ( %sex% = 1 ) then {
				set <sex; 0>
				set <name[0]; Jill>
				msg <You place your hands on the sword and pull. As you, a warm light emerges from the handle, but it doesn't budge. As you step back from the sword, you notice that you're a bit different now... Type |iinventory|xi to see what's happened, then try to take the sword again.>
			}
			else {
				msg <You are now a $gender$. You may have noticed that your name changed with your sex, #name[sex]#. Name is an array which is accessed based on sex. To display the player's current name, simply display the string variable name[sex]. To change the player's male name, change the variable name[1], or change name[0] to changer her female name. You can also use the gender function to display whether the character is currently man, woman, boy, or girl. Don't forget to check the code if you need examples.>
			}
		}
	end define

end define

define room <room3>
	alias <Blue Room>
	prefix <the>
	look <Now that you're an expert in performing sex changes, let's learn about age. Age is very, very simple. There is a numeric variable called age. Change that variable to change the player's age. Take the doll for a demonstration.>
	north <room2>
	southwest <room4>

	define object <doll>
		alias <doll>
		look <It's a simple cloth doll for a little girl.>
		take {
			set <age; 8>
			do <qna.agesize>
			hide <doll>
			msg <As you reach for the doll, there is a flash of light and the ball suddenly vanishes. You then notice that you are now younger, and therefore smaller. |iSize|xi is another important attribute which can be affected by your current age. After changing the player's age, run the qna.agesize procedure. This will set the size variable to match the new age. It will also remove any clothing which no longer fits.>
		}
		prefix <a>
	end define

end define

define room <room4>
	alias <Green Room>
	prefix <the>
	look <I've tried to keep clothing as simple as possible in this library. To make a piece of clothing, simply create an object and give it the type that matches the type of clothing you want it to be. Then give it a property of size, and set it to the size you want it to be.>
	northwest <room5>
	northeast <room3>

	define object <sizechart>
		alias <size chart>
		look <This chart lists what size the player would be at a given age, assuming you've used qna.agesize to set their size. Players can wear clothing which is 1 size above their current size. If you don't assign a size to the clothing, or assign it to size 0 then it can be worn no matter what the player's current size is. |nAge     Size|nAny     0|n0-2     1|n3-5     2|n6-8     3|n9-11    4|n12-14   5|n15-17   6|n18+     7>
		prefix <the>
	end define

	define object <typechart>
		alias <type chart>
		look <This chart displays all possible clothing types and their possible uses. See qna.txt for a more technical explination of how clothing works|n (Underwear layer) |nTeddy - Anything that covers like a teddy. One-piece swimsuits, long johns, etc. |nUndies - Panties, boxers, diapers, etc. |nBra - Bras, undershirts, etc. |n(Second layer) |nSleeper - Sleepers, wetsuits, etc. |nTights - Tights, pantyhose, stockings, etc. |nShirt - Shirts |n(Third layer) |nDress - Dresses, or anything else that covers the whole body, such as coveralls. |nPants - Pants. |nSkirt - Skirts. |nJacket - Jackets, coats, etc. |n(No layer) |nAccessory - Rings, jewelry, hats, etc. |nItems of the accessory type can be put on or removed regardless of other clothing currently being worn.>
	end define

	define object <tutu>
		alias <tutu>
		look <This is a cute little ballerina's outfit. Its type is dress and its size is 3. Of course, in a real game you'd say something like 'It looks like it will fit an 8 year old girl.' Don't forget to make your clothing items takable. The player will have a hard time wearing something she can't pick up.>
		take
		prefix <a pink>
		type <dress>
		properties <size=3>
	end define
end define

define room <room5>
	alias <Yellow Room>
	prefix <the>
	southeast <room4>
	north <room6>
	look <Now that we've made some normal clothes, let's make some magical clothes. To do this, simply make the clothes as normal, then add a before, after, or takeoff action. Look at these items for more details on how each action works.>
	define object <diaper>
		type <undies>
		properties <size=1>
		prefix <a>
		take
		action <before> {
			msg <As you fasten diaper around your waist, you suddenly feel dizzy and the room seems to grow around you.>
			set <age; 2>
			do <qna.agesize>
		}
		look <The diaper uses the before action to regress you. What this means is that it runs the action script before the clothing engine checks to see if the clothing fits you. You can use this feature if wearing a specific item of clothing will change the player's age/size. Don't forget to run qna.agesize when you do that.>
	end define
	define object <sleeper>
		type <sleeper>
		properties <size=1>
		prefix <a>
		take
		action <after> {
			set <sex; 1>
			msg <As step into the sleeper and zip it up, you feel something change inside your diaper region.>
			property <sleeper; locked>
		}
		look <The sleeper uses the after action to turn you into a boy. The after script executes after the clothing engine has made sure that the clothing will fit you. This is good if the clothing's transformation doesn't include size changes, so it has to already fit you before it will work. I also added a line into this script which gives the sleeper a property of locked. This means you can't take it off once you've put it on. It's the same trick I used in Operation: Sleepover to keep you from taking the sleeper off.>
	end define
	define object <necklace>
		type <accessory>
		properties <size=0>
		prefix <a>
		take
		action <takeoff> {
			set <age; 10>
			set <sex; 0>
			msg <When you take off the necklace, reality seems to shift around you as you turn into a preteen girl. Clothes that are 'ripped apart' aren't actually destroyed, but sent to room titled qna.destroyed.>
			do <qna.agesize>
		}
		look <The necklace uses the takeoff action to turn you into a preteen girl when you take it off. The necklace is a size 0 accessory, which means you can wear it regardless of your current size or what other clothing you're wearing. This is great for jewelry type items. The takeoff action script simply runs when you take the item off.>
	end define
end define

define room <room6>
	alias <Orange Room>
	prefix <the>
	south <room5>
	look <The only thing left to cover in this demo is the qna.playerdesc. This handy little string variable lets you add extra information to the inventory output. Grab the book for an example.>
		define object <book>
			alias <book>
			prefix <a>
			look <Once the book has added to your description, the demo's over. Have fun writing your games, and email me if you need help making the library work.>
			take {
				if ( %age% = 10 ) then {
					set <qna.playerdesc; Your red hair is tied up in braids.>
					msg <You brace yourself for a shock as you reach for the book, but nothing seems to happen. Check your inventory again.>
				}
				else msg <You can't take this yet. You haven't done everything in the yellow room.>
			}
		end define
end define